安装arm-2009q3后,执行时出现“No such file or directory”

嵌入式驱动 同时被 2 个专栏收录
4 篇文章 0 订阅
4 篇文章 0 订阅

系统:Ubuntu 14.04 LTS 64bit

安装的是已经制作打包好的工具链。
安装过程如下:
1.在/usr/local下新建arm目录,并将压缩包拷贝过来
命令:
sudo mkdir arm
2.解压
命令:
tar -jxf arm-2009q3.tar.bz2


到这里就安装完成了,但是当查看编译器版本时却出现了错误
linux@ubuntu:/usr/local/arm/arm-2009q3/bin$ ./arm-none-linux-gnueabi-gcc -v
-bash: ./arm-none-linux-gnueabi-gcc: No such file or directory

网上查找资料,运行了以下几个命令:
inux@ubuntu:/usr/local/arm/arm-2009q3/bin$ ldd arm-none-linux-gnueabi-gcc
ldd显示所依赖的动态连接库,显示No such file or directory

linux@ubuntu:/usr/local/arm/arm-2009q3/bin$ file arm-none-linux-gnueabi-gcc
arm-none-linux-gnueabi-gcc: ELF 32-bit LSB executable, Intel 80386, version 1 (SYSV), dynamically linked (uses shared libs), for GNU/Linux 2.2.5, stripped

linux@ubuntu:/usr/local/arm/arm-2009q3/bin$ readelf -l arm-none-linux-gnueabi-gcc | grep interpreter
[Requesting program interpreter: /lib/ld-linux.so.2]

从上面的结果可以看出arm-none-linux-gnueabi-gcc是32位的。运行时需要ld-linux.so.2,而在系统中查找没有发现这个文件。

由于系统是64位的,怀疑是缺少32位的兼容包。试着安装了兼容包
命令:
apt-get install libc6:i386

再次执行,成功。可以在最后一行看到
gcc version 4.4.1 (Sourcery G++ Lite 2009q3-67)

linux@ubuntu:/usr/local/arm/arm-2009q3/bin$ sudo find / -name ld-linux.so.2
/lib/i386-linux-gnu/ld-linux.so.2
/lib/ld-linux.so.2
查找需要的依赖文件,可以找到。

linux@ubuntu:/usr/local/arm/arm-2009q3/bin$ ldd arm-none-linux-gnueabi-gcc
linux-gate.so.1 => (0xf7798000)
libc.so.6 => /lib/i386-linux-gnu/libc.so.6 (0xf75d2000)
/lib/ld-linux.so.2 (0xf779b000)
ldd命令也执行成功。

  • 2
    点赞
  • 2
    评论
  • 1
    收藏
  • 打赏
    打赏
  • 扫一扫,分享海报

©️2022 CSDN 皮肤主题:大白 设计师:CSDN官方博客 返回首页

打赏作者

c909030221

你的鼓励将是我创作的最大动力

¥2 ¥4 ¥6 ¥10 ¥20
输入1-500的整数
余额支付 (余额:-- )
扫码支付
扫码支付:¥2
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值